#ifndef LCP_H
#define LCP_H

#include "DataType.h"
#include "ErrorCode.h"
#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <iostream>

/**
 *  LCP array class
 */

class LCP
{
 private:
	/// Compacted array
/*   std::vector<Byte1>  _p_array; */
/*   std::vector<UInt32> _idx_array; */
/*   std::vector<UInt32> _val_array; */

  Byte1  *_p_array;
  UInt32 *_idx_array;
  UInt32 *_val_array;
  UInt32 _size;
  
  bool _is_compact;

  UInt32 *_beg;
  UInt32 *_end;
  UInt32 *_cache;
  
/*   typedef std::vector<UInt32>::const_iterator const_itr; */
  
 /*  const_itr _beg; */
/*   const_itr _end; */

/* 	const_itr _cache; */
	UInt32 _dist;
	
 public:

  /// Original array - 4bytes
  //std::vector<UInt32>  array;    
  UInt32 *array;
	
	/// Constructors
	LCP(const UInt32 &size);

	/// Destructors
	virtual ~LCP();

	/// Methods

	/// Compact 4n bytes array into (1n+8p) bytes arrays
	ErrorCode compact(void);
  
	/// Retrieve lcp array value
	// ErrorCode lcp(const UInt32 &idx, UInt32 &value);
	
  UInt32 operator[] (const UInt32& idx); 
  
  friend std::ostream& operator << (std::ostream& os, LCP& lcp);
  
};
#endif
